SystemOrganization addCategory: #Metaprogramacion!

!Behavior class methodsFor: '*Metaprogramacion' stamp: 'pb 6/19/2013 19:47'!
messageNotPresent
	^'this class does not respond to this message'! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'pb 6/19/2013 20:40'!
subclassesNotImplementing: aMessageSelector 
	|method subclasses |
	method := self methodDictionary at: aMessageSelector ifAbsent: [
		self error: Behavior messageNotPresent 
	].

	subclasses := Set new.
	
	(self subclasses) do: [ :subclass | 
		(subclass methodDictionary includesKey: aMessageSelector ) ifFalse: [subclasses add: subclass].
	 ].

	^subclasses.! !

Object subclass: #AbstractA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractA methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:09'!
anAbstractMethod
	self subclassResponsibility ! !

!AbstractA methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:17'!
anImplementedMethod
! !

Object subclass: #AbstractB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
anAbstractMethod
	self subclassResponsibility ! !

AbstractB subclass: #AbstractSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractB subclass: #ConcreteSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:37'!
anAbstractMethod! !

Object subclass: #AbstractC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractC methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 19:32'!
notImplementedMethod
 	self subclassResponsibility.! !

AbstractC subclass: #AbstractSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractSubclassC subclass: #NestedConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractC subclass: #ConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

TestCase subclass: #MetaprogrammingTestCase
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
testShouldFailIfAskingForUnknownMethod
	self should: [AbstractA subclassesNotImplementing: #unknown] 
		 raise: Error
		 withExceptionDo: [ :anError | self assert: anError messageText = Behavior messageNotPresent].! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:22'!
testShouldListDirectSubclassesNotImplementingAbstractMethod
	| subclasses |
	subclasses := AbstractB subclassesNotImplementing: #anAbstractMethod.
	self assert: subclasses size = 1.
	self assert:  (subclasses includes: AbstractSubclassB).! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:16'!
testShouldListNoClasesOnAbstractMethodIfNoSubclasses
	| subclasses |
	subclasses := AbstractA subclassesNotImplementing: #anAbstractMethod.
	self assert: subclasses isEmpty.! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:20'!
testShouldListNoClasesOnImplementedMethod
	| subclasses |
	subclasses := AbstractA subclassesNotImplementing: #anImplementedMethod.
	self assert: subclasses isEmpty.! !
